from .helpers import SetupTeardown

from fertilizer.trackers import RedTracker, OpsTracker


class TestTrackerMethods(SetupTeardown):
  def test_source_flags_for_search(self):
    assert RedTracker.source_flags_for_search() == [b"RED", b"PTH"]
    assert OpsTracker.source_flags_for_search() == [b"OPS", b"APL"]

  def test_source_flags_for_creation(self):
    assert RedTracker.source_flags_for_creation() == [b"RED", b"PTH", b""]
    assert OpsTracker.source_flags_for_creation() == [b"OPS", b"APL", b""]

  def test_announce_url(self):
    assert RedTracker.announce_url() == b"flacsfor.me"
    assert OpsTracker.announce_url() == b"home.opsfet.ch"

  def test_site_shortname(self):
    assert RedTracker.site_shortname() == "RED"
    assert OpsTracker.site_shortname() == "OPS"

  def test_reciprocal_tracker(self):
    assert RedTracker.reciprocal_tracker() == OpsTracker
    assert OpsTracker.reciprocal_tracker() == RedTracker
